/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package cz.fallingfox.aoc

import java.io.File

fun main() {
    loadTestInput().lines().map { it.split(" ") }.map { it.map(String::toInt) }
        .map { firstRow ->
            val rows = mutableListOf(firstRow.toMutableList())
            var actualRow = firstRow

            while (actualRow.any { it != 0 }) {
                val nextRow = mutableListOf<Int>()
                for (index in (0..<actualRow.size - 1)) {
                    val a = actualRow[index]
                    val b = actualRow[index + 1]
                    val diff = (b - a)
                    nextRow.add(diff)
                }
                rows.add(nextRow)
                actualRow = nextRow
            }

            rows
        }.sumOf { pyramid ->
            var output = 0
            pyramid.reversed().forEach {
                output = it.first() - output
//                println(output)
            }
            output
        }.let { println(it) }
}

fun loadInput(filename: String) = File(filename).readText()
fun loadInput() = loadInput("input.txt")
fun loadTestInput() = loadInput("inputTest.txt")